#ifndef ADC10_H
#define ADC10_H

#include "MiniAppTypes.h"

typedef void ( * PFN_ADC10_CALLBACK_ON_EXIT_VOID_WORD )( WORD );
// Example:
// void MyHost_OnExit( WORD wADC10 );

typedef struct StructADC10_Info
// Defines parameters required to connect to the ADC10 mini-app
{	
	// The callback function to provide idle ticks
	PFN_MINI_APP_CALLBACK_ON_IDLE_VOID_VOID pfnCallback_OnIdle;

	// Pointer to the host's state pointer
	PFN_STATE_VOID_VOID * ppfnHostState;

	// The callback function to execute on exit
	PFN_ADC10_CALLBACK_ON_EXIT_VOID_WORD pfnCallback_OnExit;

	// The callback function to suspend further host ticks
	PFN_MINI_APP_CALLBACK_ON_SUSPEND_TICKS_VOID_VOID pfnCallback_OnSuspendTicks;

	// The callback function to resume host ticks
	PFN_MINI_APP_CALLBACK_ON_RESUME_TICKS_VOID_VOID pfnCallback_OnResumeTicks;

} SADC10_Info;

void ADC10_InitializeHW( void );
void ADC10_InitializeApp( void );

void ADC10_Entry( SADC10_Info const * ptADC10_Info, BYTE byChannel );

#endif
