#ifndef MONITOR_H
#define MONITOR_H

typedef void ( * PFN_MONITOR_CALLBACK_ON_EXIT_VOID_VOID )( void );
// Example:
// void MyHost_OnExit( void );

typedef void ( * PFN_MONITOR_CALLBACK_ON_SUSPEND_TICKS_VOID_VOID )( void );
// Example:
// void MyHost_OnSuspendTicks( void );

typedef void ( * PFN_MONITOR_CALLBACK_ON_RESUME_TICKS_VOID_VOID )( void );
// Example:
// void MyHost_OnResumeTicks( void );

typedef struct StructMonitorInfo
// Defines parameters required to connect to the monitor mini-app
{	
	// Pointer to the host's state pointer
	PFN_STATE_VOID_VOID * ppfnHostState;

	// The callback function to execute on exit
	PFN_MONITOR_CALLBACK_ON_EXIT_VOID_VOID pfnCallback_OnExit;

	// The callback function to suspend further host ticks
	PFN_MONITOR_CALLBACK_ON_SUSPEND_TICKS_VOID_VOID pfnCallback_OnSuspendTicks;

	// The callback function to resume host ticks
	PFN_MONITOR_CALLBACK_ON_RESUME_TICKS_VOID_VOID pfnCallback_OnResumeTicks;
	
} SMonitorInfo;

void Monitor_InitializeHW( void );
void Monitor_InitializeApp( void );

void Monitor_Entry( SMonitorInfo const * ptMonitorInfo );

#endif
