#include "msp430x22x4.h"
#include "SoftBaughTypes.h"
#include "System.h"
#include "MyApp.h"
#include "Switches.h"

void InitializeHW( void );
void InitializeApps( void );

void main( void )
{
	// Stop watchdog timer to prevent time out reset
	WDTCTL = (WDTPW | WDTHOLD);

	InitializeHW();
	InitializeApps();
	__enable_interrupt();

	while( 1 )
	{
		__low_power_mode_3();
		gMyApp_pfnCurrentState();
	}
}

void InitializeHW( void )
{
	System_InitializeHW();
	Switches_InitializeHW();
	MyApp_InitializeHW();
}

void InitializeApps( void )
{
	Switches_InitializeApp();
	MyApp_InitializeApp();
}

