#ifndef UCA0_UART_H
#define UCA0_UART_H

#ifdef __IAR_SYSTEMS_ICC__
typedef void ( * PFN_UART_RX_EVENT_SINK_VOID_VOID )( void );
#endif
// Example:
// void MyRxEventSink( void );

#define NO_RX_AVAILABLE			0xFFFF

void UCA0_UART_InitializeHW( void );
void UCA0_UART_InitializeApp( void );

// Allow client modules to register event sinks with this module
// Pass NULL to unregister the event sink
void UCA0_UART_RegisterRxEventSink( PFN_UART_RX_EVENT_SINK_VOID_VOID pfnEventSink );

// Rx Queue Functions
WORD UCA0_UART_GetCountInRxQueue( void );
WORD UCA0_UART_GetNextRxValue( void );
WORD UCA0_UART_GetNextRxValueEcho( void );
void UCA0_UART_FlushRxQueue( void );

// Tx Queue Functions
WORD UCA0_UART_GetAvailableTxQueue( void );
void UCA0_UART_QueueTxChar( BYTE byTx );
void UCA0_UART_QueueTxString( PCSZ pszTxString );
void UCA0_UART_QueueTxErasingBackspace( void );
void UCA0_UART_QueueTxHexBYTE( BYTE byTx );
void UCA0_UART_QueueTxHexWORD( WORD wTx );

#endif
