#ifndef USER_ENTRY_H
#define USER_ENTRY_H

typedef void ( * PFN_USER_ENTRY_CALLBACK_ON_MORE_VOID_WORD )( WORD );
// Example:
// void MyHost_OnMore( WORD wOut );

typedef void ( * PFN_USER_ENTRY_CALLBACK_ON_DONE_TICKS_VOID_WORD )( WORD );
// Example:
// void MyHost_OnDone( WORD wOut );

typedef void ( * PFN_USER_ENTRY_CALLBACK_ON_ABANDON_VOID_VOID )( void );
// Example:
// void MyHost_OnAbandon( void );

typedef void ( * PFN_USER_ENTRY_CALLBACK_ON_EXCESS_INPUT_VOID_BYTE )( BYTE );
// Example:
// void MyHost_OnExcessInput( BYTE byIn );

typedef struct StructUserEntryInfo
// Defines parameters required to connect to the user entry mini-app
{	
	// The callback function to report a More result
	PFN_USER_ENTRY_CALLBACK_ON_MORE_VOID_WORD pfnCallback_OnMore;

	// The callback function to report a Done result
	PFN_USER_ENTRY_CALLBACK_ON_DONE_TICKS_VOID_WORD pfnCallback_OnDone;

	// The callback function to report abandonment
	PFN_USER_ENTRY_CALLBACK_ON_ABANDON_VOID_VOID pfnCallback_OnAbandon;
	
	// The callback function to report excess input
	PFN_USER_ENTRY_CALLBACK_ON_EXCESS_INPUT_VOID_BYTE pfnCallback_OnExcessInput;

} SUserEntryInfo;

void UserEntry_InitializeHW( void );
void UserEntry_InitializeApp( void );

void UserEntry_EntryWORD( SUserEntryInfo const * ptUserEntryInfo );
void UserEntry_EntryBYTE( SUserEntryInfo const * ptUserEntryInfo );
void UserEntry_ConsumeBYTE( BYTE byIn );

#endif
